#!/usr/local/bin/perl5 -P

$page='';

while(@ARGV) {
    open(OUT,">index${page}.html");
    print OUT "<html>\n";
    print OUT "<!---  --->\n";
    print OUT "<title> contents \n";
    print OUT "</title>\n";
    print OUT "<ul>\n";
    for($i=0;$i<20 && ($_ = shift(@ARGV));$i++) {
        print STDERR "doing $_ ...";
	$file = $_; $file =~ s/\..*$//;
	$file = $file.".html";
	&c2html($_,$file);
	print OUT "<li>\n",
	    "<a href=\"$file\"> ",($NAME?$NAME:$_), "</a>\n";
        print STDERR "done.\n";
    }
    print OUT "</ul>\n";
    $page++;
    print STDERR "page $page done.\n";
    if(@ARGV) {
	print OUT "<a href=\"index.html\"> prev </a>" if ($page==2);
	print OUT "<a href=\"index",${page}-2,".html\"> prev </a>" if ($page>2);
	print OUT "<a href=\"index${page}.html\"> next </a>\n";
    } else {
	print OUT "<a href=\"index.html\"> top </a>" if ($page>3);
	print OUT "<a href=\"index",${page}-2,".html\"> prev </a>" if ($page>2);
    }
    print OUT "</html>\n";
}

sub c2html {
    my ($in,$out) = @_;
    local($_,$i);

    open(IN,$in);
    open(HTML,">$out");
    print HTML "<html>\n";
    print HTML "<!--  -->\n";
    print HTML "<title>$in</title>\n";
    print HTML "<body>\n";
    print HTML "<pre>\n";
    $i = 0;
    $NAME = '';
    while(<IN>) {
	if($i==1) {
	    $NAME = $_; $i=0;
	}
	$i=1 if(/^NAME/) ;
	if (/<a name/) { print HTML ; next ; }
	s/.//g;
	s/&/\&amp;/g;
	s/</\&lt;/g;
	s/>/\&gt;/g;
#include "keys"
	print HTML ;
    }
    print HTML "</pre>\n";
    print HTML "</body>\n";
    print HTML "</html>\n";
    close(IN); close(HTML );
}
